#!/usr/bin/perl
#--------------------------------------------------------------------
# ARRANGE (arrange.pl) Ver 1.0
# 2000/08/08 Hashimoto Zenko
#                zenko@zenko3.com  http://www.zenko3.com/
#
#   `    arrange.pl <ϊe>...
#       <ϊe> : Jn, ܂ CRX^gl
#                        ex)  3,5 CXXX C"X X X"
#   ߂l : 0 - , 10 - Error, 255 - ̑error
#   STDIN  : ̓f[^
#   STDOUT : o̓f[^
#--------------------------------------------------------------------

$me = "[arrange.pl]";	# vO

warn $me." Start ".&Now."\n";

#-- `FbN --
if ( &CheckArg() ) { exit 10; }

#-- ̓f[^ҏWďo

while( $inrec = <STDIN> ) {
	chomp( $inrec );

	$outrec = "";
	for ( $i = 0; $i <= $#edit_item; $i++ ) {
#		-- RX^gw --
		if ( $edit_const[$i] ) {
			$outrec .= $edit_item[$i];
		}
#		-- JҏW --
		else {
			$outrec .= sprintf( "%-$edit_length[$i]\s", substr( $inrec, $edit_item[$i] - 1, $edit_length[$i] ) );
		}
	}
	print "$outrec\n";
}

warn $me." End   ".&Now."\n";

exit 0;

#--------------------------------------------------------------------
# `FbN
#   `    $ret = &CheckArg();
#   ߂l  0 - , 1 - Error
#   l    @edit_const, @edit_item Ɋi[
#--------------------------------------------------------------------
sub CheckArg {
#	-- `FbN --
	if ( $#ARGV < 0 ) {
		warn "$me Requires an Argument\n";
		return 1;
	}

#	-- ݒ --
	@edit_const = ();
	@edit_item = ();

#	-- Ẍ̃`FbN --
	foreach $arg ( @ARGV ) {
#		-- RX^gw --
		if ( $arg =~ /^[Cc]/i ) {
			if ( length( $arg ) == 1 ) {
				warn "$me Constant String Nothing Error\n";
				return 1;
			}
			push( @edit_const, 1);
			push( @edit_item, substr( $arg, 1 ) );
			push( @edit_length, 0 );
		}

#		-- Jw --
		else {
			@split_arg = split( /,/, $arg );    # J}ɂ؂蕪
#			-- ؂蕪̌`FbN --
			if ( $#split_arg != 1 ) {
				warn "$me $arg : Arrange Define Error\n";
				return 1;
			}
#			-- JnȂÓ`FbN --
			$split_arg[0] = &TRim( $split_arg[0] );
			$split_arg[1] = &TRim( $split_arg[1] );
			if ( $split_arg[0] !~ /^[0-9]+$/ ||
				 $split_arg[1] !~ /^[0-9]+$/ ||
				 $split_arg[0] == 0 || $split_arg[1] == 0 ) {
				warn "$me $arg : Arrange Define Error\n";
				return 1;
			}
			push( @edit_const, 0 );
			push( @edit_item, $split_arg[0] );
			push( @edit_length, $split_arg[1] );
		}
	}
	return 0;
}

#--------------------------------------------------------------------
# O󔒍폜
#   `    $result = &TRim( $string );
#       $string : in  : ͕
#   ߂l  O󔒂菜
#--------------------------------------------------------------------
sub TRim {
	local ( $string ) = @_;

	$string =~ s/^[ @]*//;
	$string =~ s/[ @]*$//;
	return $string;
}

#--------------------------------------------------------------------
# 擾
#   `    $result = &Now;
#   ߂l  yyyy/mm/dd hh:mm:ss `̌ݓ
#--------------------------------------------------------------------
sub Now {
	package Now;
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime( time );
	$year += 1900 if ( $year < 1900 );
	$ymdhms = sprintf("%4d/%2d/%2d_%2d:%2d:%2d",$year, $mon + 1, $mday, $hour, $min, $sec);
	$ymdhms =~ tr/ _/0 /;
	return $ymdhms;
}
